VERSION 5.00
Begin VB.Form fTest 
   Caption         =   "PngCaching and Alpha-aware Rendering"
   ClientHeight    =   6060
   ClientLeft      =   120
   ClientTop       =   420
   ClientWidth     =   9195
   BeginProperty Font 
      Name            =   "Tahoma"
      Size            =   9
      Charset         =   0
      Weight          =   400
      Underline       =   0   'False
      Italic          =   0   'False
      Strikethrough   =   0   'False
   EndProperty
   LinkTopic       =   "RecvClipPngForm"
   ScaleHeight     =   404
   ScaleMode       =   3  'Pixel
   ScaleWidth      =   613
   StartUpPosition =   3  'Windows-Standard
   Begin VB.Timer tmrRefresh 
      Enabled         =   0   'False
      Interval        =   30
      Left            =   210
      Top             =   180
   End
End
Attribute VB_Name = "fTest"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = False
Attribute VB_PredeclaredId = True
Attribute VB_Exposed = False
Option Explicit 'just to show, how to make use of the two small classes

Private WithEvents Button1 As cButton, WithEvents Button2 As cButton, WithEvents Button3 As cButton
Attribute Button1.VB_VarHelpID = -1
Attribute Button2.VB_VarHelpID = -1
Attribute Button3.VB_VarHelpID = -1

Private Sub Form_Load()
  'let's set the current BackGround of the Form to an Image which doesn't contain any Alpha
  Set Me.Picture = LoadPicture(App.Path & "\Checker.jpg")
  'just another Png, which we use to render a TaskBar at the bottom of the FOrm
  PngCache.AddImage "TaskBar", App.Path & "\TaskBarGradient.png"

  'and here we add true Alpha-Channel-Png-Images to the cache (those with the 4 Button-States)
  PngCache.AddImage "Home", App.Path & "\Home.png"
  PngCache.AddImage "Seven", App.Path & "\Seven.png"
  
  'and finally we cache another Alpha-Png, which we render centered later on (directly in Form_Paint here)
  PngCache.AddImage "Alpha", App.Path & "\Test.png"
 
  Set Button1 = New cButton: Button1.InitOn Me, "Home", 20, 20
  Set Button2 = New cButton: Button2.InitOn Me, "Home", 70, 20: Button2.State = PngBtnStateDisabled
  Set Button3 = New cButton: Button3.InitOn Me, "Seven", 0, ScaleHeight - 46
End Sub

Private Sub Form_Resize()
  Button3.y = ScaleHeight - 46
  Refresh
End Sub

Private Sub Form_Paint()
  AutoRedraw = True
  Cls
  
  'here an Alpha-capable-rendering (directly from the PngCache-Class, without any cButton-Wrapping)
  PngCache.AlphaRenderTo Me.HDc, "Alpha", (ScaleWidth - PngCache.Width("Alpha")) / 2, (ScaleHeight - PngCache.Height("Alpha")) / 2

'  'and for non-alpha-rendering we can simply use VBs normal PaintPicture-method
  Me.PaintPicture PngCache.Picture("TaskBar"), 0, ScaleHeight - PngCache.Height("TaskBar"), ScaleWidth

  tmrRefresh.Enabled = True 'that's for decoupled AutoRedraw-Off-Switching
End Sub
  
Private Sub tmrRefresh_Timer()
  AutoRedraw = False
  tmrRefresh.Enabled = False
End Sub

Private Sub Button1_Click()
  MsgBox "Button1 clicked"
End Sub

Private Sub Button2_Click()
  MsgBox "Button2 clicked"
End Sub

Private Sub Button3_Click()
  MsgBox "Button3 clicked"
End Sub

